MBSRTOWCS(3)

NAME
mbsrtowcs - convert a character string to a wide-character string (restartable)

LIBRARY
libc

SYNOPSIS
#include <wchar.h>
size_t
mbsrtowcs(wchar_t * restrict dst, const char ** restrict src, size_t len, mbstate_t * restrict ps);

DESCRIPTION
The mbsrtowcs() function converts a sequence of multibyte characters pointed to indirectly by src into a sequence of corresponding wide characters and stores at most len of them in the wchar_t array pointed to by dst, until it encounters a terminating null character ('\0').

If dst is NULL, no characters are stored.

If dst is not NULL, the pointer pointed to by src is updated to point to the character after the one that conversion stopped at. If conversion stops because a null character is encountered, *src is set to NULL.

The mbstate_t argument, ps, is used to keep track of the shift state. If it is NULL, mbsrtowcs() uses an internal, static mbstate_t object, which is initialized to the initial conversion state at program startup.

RETURN VALUES
The mbsrtowcs() function returns the number of wide characters stored in the array pointed to by dst if successful, otherwise it returns (size_t)-1.

ERRORS
The mbsrtowcs() function will fail if:

[EILSEQ]
    An invalid multibyte character sequence was encountered.

[EINVAL]
    The conversion state is invalid.

SEE ALSO
mbrtowc(3), mbstowcs(3), multibyte(3), wcsrtombs(3)

STANDARDS
The mbsrtowcs() function conforms to isoC-99.